<?php

/* * *************************************************************
*  Copyright notice
*
*  (c) 2010-2011 - Daniel Lorenz <daniel.lorenz@capsicum-ug.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
* ************************************************************* */

require_once(PATH_tslib . 'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('wt_cart') . 'lib/class.tx_wtcart_div.php'); // file for div functions
require_once(t3lib_extMgm::extPath('wt_cart') . 'lib/class.tx_wtcart_dynamicmarkers.php'); // file for dynamicmarker functions

/**
* plugin 'Form to Cart' for the 'wt_cart' extension.
*
* @author  Daniel Lorenz <daniel.lorenz@capsicum-ug.de>
* @package TYPO3
* @subpackage  tx_wtcart
* @version 1.0.0
*/
class tx_wtcart_pi2 extends tslib_pibase
{
	public $prefixId = 'tx_wtcart_pi2';

	// same as class name
	public $scriptRelPath = 'pi2/class.tx_wtcart_pi2.php';

	// path to this script relative to the extension dir.
	public $extKey = 'wt_cart';

	/**
	* the main method of the PlugIn
	*
	* @param string    $content: The PlugIn content
	* @param array   $conf: The PlugIn configuration
	* @return  The content that is displayed on the website
	*/	
	public function main($content, $conf)
	{
		// config
		global $TSFE;
		$local_cObj = $TSFE->cObj; // cObject
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->div = t3lib_div::makeInstance('tx_wtcart_div'); // Create new instance for div functions
		$this->dynamicMarkers = t3lib_div::makeInstance('tx_wtcart_dynamicmarkers', $this->scriptRelPath); // Create new instance for dynamicmarker function
		
		$this->tmpl['form'] = $this->cObj->getSubpart($this->cObj->fileResource($this->conf['main.']['template']), '###WTCART_FORM###'); // Load FORM HTML Template
		
		$formMarkerArray['###WTCART_FORM_ACTION_PID###'] = $this->conf['main.']['pid'];
		$formMarkerArray['###WTCART_FORM_ACTION###'] = $this->pi_getPageLink($this->conf['main.']['pid']);
		$formMarkerArray['###WTCART_FORM_CONTENTUID###'] = $this->cObj->data['uid'];
		
		$this->content = $this->cObj->substituteMarkerArrayCached($this->tmpl['form'], null, $formMarkerArray); // Get html template
		$this->content = $this->dynamicMarkers->main($this->content, $this); // Fill dynamic locallang or typoscript markers
		//$this->content = preg_replace('|###.*?###|i', '', $this->content); // Finally clear not filled markers
		return $this->pi_wrapInBaseClass($this->content);
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/wt_cart/pi2/class.tx_wtcart_pi2.php'])
{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/wt_cart/pi2/class.tx_wtcart_pi2.php']);
}
?>